\documentclass[14pt,xcolor=dvipsnames,presentation,aspectratio=169]{beamer}
\usepackage[utf8]{inputenc}

% Font
%\usepackage[default]{lato}
%\usepackage{helvet}
%\usepackage[default]{cantarell}
%\usepackage[sfdefault]{biolinum}
%\usepackage{cmbright}
\usepackage[sfdefault,lf]{carlito}
\renewcommand*\oldstylenums[1]{\carlitoOsF #1}


\usepackage[T1]{fontenc}
\usepackage{fixltx2e}
\usepackage{graphicx}
\usepackage{grffile}
\usepackage{longtable}
\usepackage[export]{adjustbox}[2011/08/13]
\usepackage{wrapfig}
\usepackage{rotating}
\usepackage[normalem]{ulem}
\usepackage{amsmath}
\usepackage{textcomp}
\usepackage{amssymb}
\usepackage{capt-of}
\usepackage{hyperref}
\usedescriptionitemofwidthas{bl}
\usepackage{ifthen,figlatex,amsmath,amstext,xspace}
\usepackage{boxedminipage,xspace,multicol}
\usepackage{subfigure}
\usepackage{algorithm2e}
\usepackage{hhline}
\usepackage{multirow}
\usepackage{booktabs}

%\usetheme{Madrid}
%\usecolortheme[named=BrickRed]{structure}

\useoutertheme{default}
\useinnertheme{default}

\setbeamercolor*{frametitle}{fg=orange,bg=white}
\setbeamercolor*{lower separation line head}{bg=DeepSkyBlue4} 
\setbeamercolor*{normal text}{fg=black,bg=white} 
\setbeamercolor*{alerted text}{fg=red} 
\setbeamercolor*{example text}{fg=black} 
%\setbeamercolor*{structure}{fg=black} 
% 
\setbeamercolor*{palette tertiary}{fg=black,bg=black!10} 
\setbeamercolor*{palette quaternary}{fg=black,bg=black!10} 
%
\definecolor{my-light-blue}{HTML}{D3DCEC}
\definecolor{my-dark-blue}{HTML}{093A7A}
\definecolor{my-dark-blue2}{HTML}{00688B}
\definecolor{my-light-red}{HTML}{FFBABA}
\definecolor{my-dark-red}{HTML}{D51111}
%\definecolor{my-light-orange}{HTML}{F2B76E}
\definecolor{my-light-orange}{HTML}{FFD8B2}
%\definecolor{my-dark-orange}{HTML}{FFA500}
%\definecolor{my-dark-orange}{HTML}{CF7C00}
\definecolor{my-dark-orange}{HTML}{FE8D00}
\definecolor{my-light-green}{HTML}{BFFFBF}
\definecolor{my-dark-green}{HTML}{00B000}
\definecolor{my-light-grey}{HTML}{E6E6E6}

\setbeamertemplate{blocks}[rounded]
\setbeamercolor{block body}{bg=my-light-orange}
\setbeamercolor{block title}{bg=my-dark-orange,fg=white}
\setbeamercolor{block body alerted}{bg=my-light-red}
\setbeamercolor{block title alerted}{bg=my-dark-red,fg=white}
\setbeamercolor{block body example}{bg=my-light-green}
\setbeamercolor{block title example}{bg=my-dark-green,fg=white}

\setbeamertemplate{footline}[frame number]
\setbeamertemplate{navigation symbols}{}

% \usepackage[colorlinks=true,citecolor=pdfcitecolor,urlcolor=pdfurlcolor,linkcolor=pdflinkcolor,pdfborder={0 0 0}]{hyperref}

\usepackage[round-precision=3,round-mode=figures,scientific-notation=true]{siunitx}
\usetheme{default}
\date{13 September 2023}
\title{Introduction to DevOps for experimental research}
\hypersetup{
 pdfauthor={Baptiste Jonglez},
 pdftitle={Introduction to DevOps for experimental research},
 pdfkeywords={},
 pdfsubject={},
 pdfcreator={},
 pdflang={English}}


\begin{document}

\urlstyle{sf}
\let\alert=\structure
\let\epsilon=\varepsilon
\let\leq=\leqslant
\let\geq=\geqslant


\author{Baptiste Jonglez, Inria}

\maketitle

\begin{frame}{Goal}
\textbf{Introduction} to DevOps: we will cover many subjects, none in-depth.
Goal = understand concepts and tools, and give pointers to go further.
\textbf{Go explore yourself, and tell us if you need more advanced training.}

\vspace{1cm}

For \textbf{experimental research}: DevOps is not a research methodology.
But some ideas and tools can be used for research.
\end{frame}

\begin{frame}{Overview of the training day}
\textbf{Now:} intro, definitions

\vspace{1cm}

\textbf{Rest of the morning:} focused on building, packaging and reproducility

\vspace{1cm}

\textbf{Afternoon:} Focused on provisioning and deployment

\vspace{1cm}

\textbf{Presenters:} Baptiste Jonglez (SED), Matthieu Simonin (SED),
Guillermo Andrade Barroso (SED), Volodia Parol-Guarino (PhD Myriads),
Pierre Neyron (CNRS Grenoble)

\end{frame}

\begin{frame}{What is DevOps?}
\textbf{Methodology} to improve the speed and quality of software
\textbf{development} and \textbf{operation} through \textbf{automation}
\begin{figure}
  \centering
  \includegraphics[width=0.8\textwidth]{figures/devops.png}
\end{figure}
\end{frame}

\begin{frame}{Some related definitions (1)}
\textbf{Automation:} automated processes shared by a team, with well-defined tasks
and results (often using git and CI/CD).  As opposed to manual processes
(individual scripts or commands)

\vspace{1cm}

\textbf{CI (Continuous Integration):} automated process that runs for each
code change (e.g. static code analysis, run tests, build documentation)

\vspace{1cm}

\textbf{CD (Continuous Delivery):} automated process to release and deploy
a software project.
\end{frame}

\begin{frame}{Some related definitions (2)}
\textbf{SRE (Site Reliability Engineering):} developed by Google, similar to
DevOps, focused on large-scale production systems and availability metrics

\vspace{1cm}

\textbf{Infrastructure as Code:} declarative definition and maintenance of
necessary infrastructure (virtual machines, networks, firewalls,
load-balancers, databases...).  Often using git.
\end{frame}

\begin{frame}{Requirements for DevOps}
\textbf{Good development methodologies:} modular design, dependency
tracking (e.g. lockfiles), git, code review, static code analysis,
automated testing (unit tests, integration tests).

\vspace{1cm}

\textbf{With no automated testing, DevOps will simply deploy crappy code really fast!}

\vspace{1cm}

Fortunately, the SED provides training for good practices in software developement.
\end{frame}

\begin{frame}{How to follow the training}
We will alternate between presentations and tutorials (demos).
You can try to reproduce the tutorials during the tutorial sessions, but
time will be short.

\vspace{1cm}

Clone this repo with everything: \url{https://gitlab.inria.fr/sed-rennes/formations/devops-tutorial}

\vspace{1cm}

Requirements for the tutorials: Linux, Docker or podman.  A Grid'5000 account is recommended.
\end{frame}


\end{document}
